// cppdebug.C
//
// cint debug interface demo program. "$ cint cppdebug.C" to start
//
#include <iostream.h>

main()
{
  int a=1,b=2,c;
  cout << "\n";
  cout << "**********************************************************\n";
  cout << "* Welcome to cint debug capability demonstration for C++.\n" ;
  cout << "* Please follow instruction written as comment\n" ;
  cout << "**********************************************************\n";
  cout << "\n";
  cout << "To debug source code, you need to start cint with -S or -b\n";
  cout << "\n";
  cout << "    $ cint -S [source].C     # step execution\n";
  cout << "    $ cint -b 10 [source].c  # break at line 10\n";
  cout << "\n";
  cout << "Then, stopped source line and following prompt is shown.\n";
  
  G__stepmode(1);
  // Follow the instruction,
  //
  // Now you are debugging C++ program. There are several classes in this 
  // program. To list them up, input 'class' and RETURN.
  // 
  // Input "S" and RETURN to step to next statement
	
  person me=person("Saitama","Masa",32,"male");
  
  cout << " address=" << me.address 
       << " name=" << me.name 
       << " age=" << me.age 
       << " Gender=" << me.S()
       << "\n";
  
	person *pme;
	pme = new person;

	cout << " address=" << pme->address 
	     << " name=" << pme->name 
	     << " age=" << pme->age 
	     << " Gender=" << pme->S()
	     << "\n";

	delete pme;
}


func(int a,int b,int *pc)
{
	// You came into the function. 

	// Input "v" and return to list source code
	*pc=a+b;

	int i;
	double ary[1000];
	for(i=0;i<1000;i++) ary[i] = i;
}

//   '->' represents where you are.  
//
//   Input "e" and Return to step out from the functioin
//


//
// class inheritance test 1
//
// constructor, destructor
//
#include <iostream.h>

class string {
      private:
	char *p;
      public:
	string(char *set) { 
		cout << "construct string(" << set << ")\n";
		p=(char*)malloc(strlen(set)+1);
		strcpy(p,set);
	}
	int len() { return(strlen(p)); }
	char *s() { return(p); }

	~string() { 
		cout << "destruct ~string(" << p << ")\n"; 
		free(p); 
	}
};

ostream& operator <<(ostream& ios,string& x) 
{
	ios << x.s() ;
	return(ios);
}

class gender {
      private:
	char *male;
	string Gender;
      public:
	gender(char *set) : Gender(set) { 
		cout << "construct gender(" << set << ")\n";
		male=(char*)malloc(strlen(set)+1);
		strcpy(male,set);
	}
	char *S() { return(male); }
	~gender() { 
		cout << "destruct ~gender(" << male<< ")\n";
		free(male); 
	}
};

class person : public gender {
      public:
	string address;
	string name;
	int age;
	person(void);
	person(char *adr,char *nm,int ag,char *setgender);
};

person::person(void) 
:address("SAITAMA"),name("MASAHARU"),gender("MALE")
{
	age = 33;
	cout << "construct person(" << age << ")\n";
}

person::person(char *adr,char *nm,int ag,char *setgender) 
: address(adr) , name(nm) , gender(setgender)
{
	cout << "construct person(" << ag << ")\n";
	age = ag;
}

